# How to contribute

First off, thanks for taking the time to contribute!

## Submitting changes

Please send a [GitHub Pull Request](https://github.com/Cyclenerd/ethereum_nvidia_miner/pull/new/master) with a clear list of what you've done (read more about [pull requests](http://help.github.com/pull-requests/)).

Always write a clear log message for your commits. One-line messages are fine for small changes, but bigger changes should look like this:

    $ git commit -m "A brief summary of the commit
    > 
    > A paragraph describing what changed and its impact."


## Coding style

Start reading the code and you'll get the hang of it. It is optimized for readability:

* Variables must be uppercase and must begin with `MY_`.
* Functions must be lower case and must begin with `my_`.
* Check your shell scripts with [ShellCheck](https://www.shellcheck.net/) before submitting.
* Please use four spaces to indent.

One more thing:

* Keep it simple! 👍

Thanks! ❤️❤️❤️